//Pinbelegung festlegen
#define stepPin 5
#define dirPin 4
#define hubPin 6
#define glockePin 2

// Stepperbewegung vor- und rückwärts
const int forSteps = 180;
const int backSteps = 100;

// Variablen für Schaltkontrolle des Interrupts
volatile unsigned long alteZeit = 0, entprellZeit = 20;

void setup() {
  Serial.begin(9600);

  // Pin für den Stepper
  pinMode(stepPin, OUTPUT);
  pinMode(dirPin, OUTPUT);

  // Pin für den Hubmagneten
  pinMode(hubPin, OUTPUT);

  // Pin für die Glocke
  pinMode(glockePin, INPUT_PULLUP);
  attachInterrupt(0, interruptRoutine, FALLING);
}
void loop() {

  //Serielle Daten empfangen
  if (Serial.available() > 0) {
    int incoming = Serial.read();

    switch (incoming) {
      case '0':

        //Kartenausgabe (Steppersteuerung)
        digitalWrite(dirPin, HIGH);
        for (int i = 0; i <= forSteps; i++) {
          digitalWrite(stepPin, HIGH);
          delayMicroseconds(800);
          digitalWrite(stepPin, LOW);
          delayMicroseconds(800);
        }
        delay(100);
        digitalWrite(dirPin, LOW);
        for (int i = 0; i < backSteps; i++) {
          digitalWrite(stepPin, HIGH);
          delayMicroseconds(800);
          digitalWrite(stepPin, LOW);
          delayMicroseconds(800);
        }
        break;

      case '1':

        //Glockenklingeln (Hubmagnetensteuerung)
        digitalWrite(hubPin, HIGH);
        delay(60);
        digitalWrite(hubPin, LOW);
        break;
    }
  }
}

void interruptRoutine() {
  //Senden von Daten, wenn die Glocke geklingelt wurde
  if ((millis() - alteZeit) > entprellZeit) {
    Serial.write('2');
    alteZeit = millis();
  }
  //Der Entprellalgorithmus sorgt dafür, dass beim betätigen der Glocke nur einmal eine 1 übertragen wird.
}
