class Box {
  int x;
  int y;
  int dx;
  int dy;
  Capture cam;

  //Variable für durchschnittsfrabe
  color theColor;
  //Farbreferenzen
  color[] colorReference = {#cd5c5c, #a8e4a0, #9c9c6F, #7848a7, #b7b7b7};
  int[] colorThreshold = {70, 50, 70, 80, 50};
  String[] colorName = {"Rot","Grün","Gelb","Lila","null"};
  
  Box(int x, int y, int dx, int dy, Capture camera) {
    this.x = x;
    this.y = y;
    this.dx = dx;
    this.dy = dy;
    this.cam = camera;
    
    //this.colorReference = loadReference("colorReference.json");
    //this.colorThreshold = loadThreshold("coloThreshold.json");
  }
  
  //Methode zum Anzeigen der Box
  void show() {
    avr_color();
    noFill();
    rect(this.x, this.y, dx, dy);
    fill(255);
    text(getColor(),this.x,this.y+20);
  }
  
  //Berechnung der Durchschnittsfarbe der Box
  void avr_color() {
    float r = 0;
    float g = 0;
    float b = 0;
    for (int i = this.x; i < (this.dx + this.x); i++) {
      for (int j = this.y; j < (this.dy + this.y); j++) {
        int k = i + j * width;
        color pixel = cam.pixels[k];
        r += red(pixel);
        g += green(pixel);
        b += blue(pixel);
      }
    }

    r /= (dx*dy);
    g /= (dx*dy);
    b /= (dx*dy);

    //print(r + "\t" + r +"\t" + g +"\n");
    this.theColor = color(r, g, b);
    
    //Berechnete Durchschnittsfarbe in der Box anzeigen
    fill(this.theColor);
    rect(this.x, this.y, dx, (0.3*dy));
  }
  
  //Farbvergleich mit den Referenzwerten
  String getColor() {
    for (int i = 0; i < colorReference.length; i++) {
      float delta = dist(red(theColor), green(theColor), blue(theColor), red(colorReference[i]), green(colorReference[i]), blue(colorReference[i]));
      if (abs(delta) < colorThreshold[i]) {
        return colorName[i];
      }
    }
    return ("" + dist(red(theColor), green(theColor), blue(theColor), red(colorReference[0]), green(colorReference[0]), blue(colorReference[0])));
  }
  
  String toString() {
    return ("x: " + this.x + "\ty: " + this.y + "\tdx: " + this.dx + "\tdy: " + this.dy);
  }

}