class Camera {

  Capture cam;
  public Card[] karten;

  Camera(PApplet location) {
    surface.setSize(864, 480);

    //Verfügbare Kameras auslesen
    String[] cameras = Capture.list();


    if (cameras.length == 0) {
      println("There are no cameras available for capture.");
      exit();
    } else {
      println("Available cameras:");
      for (int i = 0; i < cameras.length; i++) {
        println(i + ": " + cameras[i]);
      }
    }


    //Verbindung eherstellen
    println("> Versuche Verbindung zur Kamera aufzubauen ...");
    try {
      cam = new Capture(location, cameras[24]); //Logitech Webcam
    } 
    catch (Exception excp) {
      System.err.println("! Keine Verbindung zur Kamera möglich (" + excp + ")");
      System.err.println("! Interne Kamera wird jetzt verwendet");
      cam = new Capture(location, cameras[1]); //intigrierte Webcam
      surface.setSize(640, 480);
    }
    println("> Verbindung zur Kamera hergestellt.");

    //Kamera starten
    cam.start();
    cam.loadPixels();

    //Boxsetup
    karten = new Card[2];
    karten[0] = new Card("card_com.json", cam);
    karten[1] = new Card("card_hum.json", cam);
    println(karten[0]);  
    println(karten[1]);
  }

  void update() {
    clear();
    if (cam.available() == true) {
      cam.read();
    }
    image(cam, 0, 0);

    if (cam.pixels.length > 0) {
      karten[0].show();
      karten[1].show();
      fill(255);
      /*
        text(hex(fenster.Filler, 6), fenster.x, fenster.y);
       text(fenster.getColor(), fenster.x+70, fenster.y);
       */
    }
  }

  boolean checkwin() {

    //Farbfelder zusammenrechnen
    int[] temp = new int[4];
    int[] a = karten[0].getColors();
    int[] b = karten[1].getColors();

    for (int i  = 0; i < temp.length; i++) {
      temp[i] += a[i];
      temp[i] += b[i];
    }

    //Überprüfen, ob fünf von einer Farbe vorhanden sind
    for (int i = 0; i < temp.length; i++) {
      if (temp[i] >= 5) {
        return true;
      }
    }

    return false;
  }
}