/*
Die hier aufgelisteten Methoden sind nur dazu da Datenstrukturen wie die Box
in einer seperaten Datei zu speichern und laden zu können. 
*/

//Boxen speichern
void saveSetup(Box[] input, String filename) {
  JSONArray jsonArray = new JSONArray();
  for (int k = 0; k < input.length; k++) {
    JSONObject json = new JSONObject();
    json.setInt("id", k);
    json.setInt("x", input[k].x);
    json.setInt("y", input[k].y);
    json.setInt("dx", input[k].dx);
    json.setInt("dy", input[k].dy);

    jsonArray.setJSONObject(k, json);
  }
  saveJSONArray(jsonArray, filename);
}

void saveSetup(Box[] input) {
  saveSetup(input, "setup.json");
}

//Boxen laden
Box[] loadSetup(String filename, Capture cam) {
  Box[] output;
  JSONArray jsonArray = loadJSONArray(filename);
  output = new Box[jsonArray.size()];
  for (int k = 0; k < jsonArray.size(); k++) {
    JSONObject json = jsonArray.getJSONObject(k);

    int id = json.getInt("id");
    int x = json.getInt("x");
    int y = json.getInt("y");
    int dx = json.getInt("dx");
    int dy = json.getInt("dy");

    output[id] = new Box(x, y, dx, dy, cam);
  }
  return output;
}

//Farben (Referenzen) laden
color[] loadReference(String filename) {
  color[] output = new color[4];
  JSONObject json = loadJSONObject(filename);
  output[0] = json.getInt("red");
  output[1] = json.getInt("green");
  output[2] = json.getInt("yellow");
  output[3] = json.getInt("purple");
  
  return output;
}

color[] loadReference() {
  return loadReference("colorReference.json");
}

//Farben (Threshold) laden
int[] loadThreshold(String filename) {
  int[] output = new int[4];
  JSONObject json = loadJSONObject(filename);
  output[0] = json.getInt("red");
  output[1] = json.getInt("green");
  output[2] = json.getInt("yellow");
  output[3] = json.getInt("purple");
  
  return output;
}

int[] loadThreshold() {
  return loadThreshold("colorThreshold.json");
}